##// END OF EJS Templates
add: REQUIRED_PACKAGES -- libssl-dev for kernel building
Sven Ginka -
r702:900fc494e871
parent child
Show More
@@ -1,883 +1,883
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63 # Kernel deb packages for 32bit kernel
64 64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 68 # Default precompiled 64bit kernel
69 69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 70 # Generic
71 71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 72 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
73 73 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
74 74
75 75 # Build directories
76 76 WORKDIR=$(pwd)
77 77 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
78 78 BUILDDIR="${BASEDIR}/build"
79 79
80 80 # Chroot directories
81 81 R="${BUILDDIR}/chroot"
82 82 ETC_DIR="${R}/etc"
83 83 LIB_DIR="${R}/lib"
84 84 BOOT_DIR="${R}/boot/firmware"
85 85 KERNEL_DIR="${R}/usr/src/linux"
86 86 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
87 87 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
88 88
89 89 # Firmware directory: Blank if download from github
90 90 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
91 91
92 92 # General settings
93 93 SET_ARCH=${SET_ARCH:=32}
94 94 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
95 95 PASSWORD=${PASSWORD:=raspberry}
96 96 USER_PASSWORD=${USER_PASSWORD:=raspberry}
97 97 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
98 98 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
99 99 EXPANDROOT=${EXPANDROOT:=true}
100 100 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
101 101
102 102 # Keyboard settings
103 103 XKB_MODEL=${XKB_MODEL:=""}
104 104 XKB_LAYOUT=${XKB_LAYOUT:=""}
105 105 XKB_VARIANT=${XKB_VARIANT:=""}
106 106 XKB_OPTIONS=${XKB_OPTIONS:=""}
107 107
108 108 # Network settings (DHCP)
109 109 ENABLE_DHCP=${ENABLE_DHCP:=true}
110 110
111 111 # Network settings (static)
112 112 NET_ADDRESS=${NET_ADDRESS:=""}
113 113 NET_GATEWAY=${NET_GATEWAY:=""}
114 114 NET_DNS_1=${NET_DNS_1:=""}
115 115 NET_DNS_2=${NET_DNS_2:=""}
116 116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
117 117 NET_NTP_1=${NET_NTP_1:=""}
118 118 NET_NTP_2=${NET_NTP_2:=""}
119 119
120 120 # APT settings
121 121 APT_PROXY=${APT_PROXY:=""}
122 122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
123 123 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
124 124
125 125 # Feature settings
126 126 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
127 127 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
128 128 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
129 129 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
130 130 ENABLE_I2C=${ENABLE_I2C:=false}
131 131 ENABLE_SPI=${ENABLE_SPI:=false}
132 132 ENABLE_IPV6=${ENABLE_IPV6:=true}
133 133 ENABLE_SSHD=${ENABLE_SSHD:=true}
134 134 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
135 135 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
136 136 ENABLE_SOUND=${ENABLE_SOUND:=true}
137 137 ENABLE_DBUS=${ENABLE_DBUS:=true}
138 138 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
139 139 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
140 140 ENABLE_XORG=${ENABLE_XORG:=false}
141 141 ENABLE_WM=${ENABLE_WM:=""}
142 142 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
143 143 ENABLE_USER=${ENABLE_USER:=true}
144 144 USER_NAME=${USER_NAME:="pi"}
145 145 ENABLE_ROOT=${ENABLE_ROOT:=false}
146 146 ENABLE_QEMU=${ENABLE_QEMU:=false}
147 147 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
148 148
149 149 # SSH settings
150 150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
151 151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
152 152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
153 153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
154 154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
155 155
156 156 # Advanced settings
157 157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
163 163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
165 165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
166 166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
167 167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
168 168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
169 169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
170 170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
171 171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
172 172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
173 173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
174 174 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
175 175 ENABLE_LOGO=${ENABLE_LOGO:=true}
176 176 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
177 177 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
178 178
179 179 # Kernel compilation settings
180 180 BUILD_KERNEL=${BUILD_KERNEL:=true}
181 181 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
182 182 KERNEL_THREADS=${KERNEL_THREADS:=1}
183 183 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
184 184 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
185 185 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
186 186 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
187 187 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
188 188 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
189 189 KERNEL_VIRT=${KERNEL_VIRT:=false}
190 190 KERNEL_BPF=${KERNEL_BPF:=false}
191 191 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
192 192 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
193 193 KERNEL_NF=${KERNEL_NF:=false}
194 194
195 195 # Kernel compilation from source directory settings
196 196 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
197 197 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
198 198 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
199 199 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
200 200
201 201 # Reduce disk usage settings
202 202 REDUCE_APT=${REDUCE_APT:=true}
203 203 REDUCE_DOC=${REDUCE_DOC:=true}
204 204 REDUCE_MAN=${REDUCE_MAN:=true}
205 205 REDUCE_VIM=${REDUCE_VIM:=false}
206 206 REDUCE_BASH=${REDUCE_BASH:=false}
207 207 REDUCE_HWDB=${REDUCE_HWDB:=true}
208 208 REDUCE_SSHD=${REDUCE_SSHD:=true}
209 209 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
210 210
211 211 # Encrypted filesystem settings
212 212 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
213 213 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
214 214 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
215 215 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
216 216 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
217 217 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
218 218 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
219 219 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
220 220 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
221 221
222 222 # Chroot scripts directory
223 223 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
224 224
225 225 # Packages required in the chroot build environment
226 226 APT_INCLUDES=${APT_INCLUDES:=""}
227 227 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
228 228
229 229 # Packages to exclude from chroot build environment
230 230 APT_EXCLUDES=${APT_EXCLUDES:=""}
231 231
232 232 # Packages required for bootstrapping
233 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex sudo"
233 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
234 234 MISSING_PACKAGES=""
235 235
236 236 # Packages installed for c/c++ build environment in chroot (keep empty)
237 237 COMPILER_PACKAGES=""
238 238
239 239 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
240 240 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
241 241 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
242 242 APT_PROXY=http://127.0.0.1:3142/
243 243 fi
244 244
245 245 # Setup architecture specific settings
246 246 if [ -n "$SET_ARCH" ] ; then
247 247 # 64-bit configuration
248 248 if [ "$SET_ARCH" = 64 ] ; then
249 249 # General 64-bit depended settings
250 250 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
251 251 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
252 252 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
253 253
254 254 # Raspberry Pi model specific settings
255 255 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
256 256 if [ "$RPI_MODEL" != 4 ] ; then
257 257 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
258 258 else
259 259 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
260 260 fi
261 261
262 262 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
263 263 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
264 264 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
265 265 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
266 266 else
267 267 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
268 268 exit 1
269 269 fi
270 270 fi
271 271
272 272 # 32-bit configuration
273 273 if [ "$SET_ARCH" = 32 ] ; then
274 274 # General 32-bit dependend settings
275 275 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
276 276 KERNEL_ARCH=${KERNEL_ARCH:=arm}
277 277 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
278 278
279 279 # Raspberry Pi model specific settings
280 280 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
281 281 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
282 282 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
283 283 RELEASE_ARCH=${RELEASE_ARCH:=armel}
284 284 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
285 285 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
286 286 fi
287 287
288 288 # Raspberry Pi model specific settings
289 289 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
290 290 if [ "$RPI_MODEL" != 4 ] ; then
291 291 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
292 292 else
293 293 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
294 294 fi
295 295
296 296 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
297 297 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
298 298 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
299 299 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
300 300 fi
301 301 fi
302 302 # SET_ARCH not set
303 303 else
304 304 echo "error: Please set '32' or '64' as value for SET_ARCH"
305 305 exit 1
306 306 fi
307 307 # Device specific configuration and U-Boot configuration
308 308 case "$RPI_MODEL" in
309 309 0)
310 310 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
311 311 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
312 312 ;;
313 313 1)
314 314 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
315 315 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
316 316 ;;
317 317 1P)
318 318 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
319 319 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
320 320 ;;
321 321 2)
322 322 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
323 323 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
324 324 ;;
325 325 3)
326 326 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
327 327 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
328 328 ;;
329 329 3P)
330 330 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
331 331 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
332 332 ;;
333 333 4)
334 334 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
335 335 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
336 336 ;;
337 337 *)
338 338 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
339 339 exit 1
340 340 ;;
341 341 esac
342 342
343 343 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
344 344 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
345 345 # Include bluetooth packages on supported boards
346 346 if [ "$ENABLE_BLUETOOTH" = true ] ; then
347 347 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
348 348 fi
349 349 if [ "$ENABLE_WIRELESS" = true ] ; then
350 350 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
351 351 fi
352 352 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
353 353 # Check if the internal wireless interface is not supported by the RPi model
354 354 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
355 355 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
356 356 exit 1
357 357 fi
358 358 fi
359 359
360 360 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
361 361 echo "error: You have to compile kernel sources, if you want to enable nexmon"
362 362 exit 1
363 363 fi
364 364
365 365 # Prepare date string for default image file name
366 366 DATE="$(date +%Y-%m-%d)"
367 367 if [ -z "$KERNEL_BRANCH" ] ; then
368 368 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
369 369 else
370 370 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
371 371 fi
372 372
373 373 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
374 374 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
375 375 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
376 376 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
377 377 exit 1
378 378 fi
379 379 fi
380 380
381 381 # Add cmake to compile videocore sources
382 382 if [ "$ENABLE_VIDEOCORE" = true ] ; then
383 383 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
384 384 fi
385 385
386 386 # Add deps for nexmon
387 387 if [ "$ENABLE_NEXMON" = true ] ; then
388 388 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
389 389 fi
390 390
391 391 # Add libncurses5 to enable kernel menuconfig
392 392 if [ "$KERNEL_MENUCONFIG" = true ] ; then
393 393 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
394 394 fi
395 395
396 396 # Add ccache compiler cache for (faster) kernel cross (re)compilation
397 397 if [ "$KERNEL_CCACHE" = true ] ; then
398 398 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
399 399 fi
400 400
401 401 # Add cryptsetup package to enable filesystem encryption
402 402 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
403 403 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
404 404 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
405 405
406 406 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
407 407 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
408 408 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
409 409 fi
410 410
411 411 if [ -z "$CRYPTFS_PASSWORD" ] ; then
412 412 echo "error: no password defined (CRYPTFS_PASSWORD)!"
413 413 exit 1
414 414 fi
415 415 ENABLE_INITRAMFS=true
416 416 fi
417 417
418 418 # Add initramfs generation tools
419 419 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
420 420 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
421 421 fi
422 422
423 423 # Add device-tree-compiler required for building the U-Boot bootloader
424 424 if [ "$ENABLE_UBOOT" = true ] ; then
425 425 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
426 426 fi
427 427
428 428 if [ "$ENABLE_USBBOOT" = true ] ; then
429 429 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
430 430 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
431 431 exit 1
432 432 fi
433 433 fi
434 434
435 435 # Check if root SSH (v2) public key file exists
436 436 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
437 437 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
438 438 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
439 439 exit 1
440 440 fi
441 441 fi
442 442
443 443 # Check if $USER_NAME SSH (v2) public key file exists
444 444 if [ -n "$SSH_USER_PUB_KEY" ] ; then
445 445 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
446 446 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
447 447 exit 1
448 448 fi
449 449 fi
450 450
451 451 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
452 452 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
453 453 exit 1
454 454 fi
455 455
456 456 # Check if all required packages are installed on the build system
457 457 for package in $REQUIRED_PACKAGES ; do
458 458 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
459 459 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
460 460 fi
461 461 done
462 462
463 463 # If there are missing packages ask confirmation for install, or exit
464 464 if [ -n "$MISSING_PACKAGES" ] ; then
465 465 echo "the following packages needed by this script are not installed:"
466 466 echo "$MISSING_PACKAGES"
467 467
468 468 printf "\ndo you want to install the missing packages right now? [y/n] "
469 469 read -r confirm
470 470 [ "$confirm" != "y" ] && exit 1
471 471
472 472 # Make sure all missing required packages are installed
473 473 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
474 474 fi
475 475
476 476 # Check if ./bootstrap.d directory exists
477 477 if [ ! -d "./bootstrap.d/" ] ; then
478 478 echo "error: './bootstrap.d' required directory not found!"
479 479 exit 1
480 480 fi
481 481
482 482 # Check if ./files directory exists
483 483 if [ ! -d "./files/" ] ; then
484 484 echo "error: './files' required directory not found!"
485 485 exit 1
486 486 fi
487 487
488 488 # Check if specified KERNELSRC_DIR directory exists
489 489 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
490 490 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
491 491 exit 1
492 492 fi
493 493
494 494 # Check if specified UBOOTSRC_DIR directory exists
495 495 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
496 496 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
497 497 exit 1
498 498 fi
499 499
500 500 # Check if specified VIDEOCORESRC_DIR directory exists
501 501 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
502 502 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
503 503 exit 1
504 504 fi
505 505
506 506 # Check if specified FBTURBOSRC_DIR directory exists
507 507 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
508 508 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
509 509 exit 1
510 510 fi
511 511
512 512 # Check if specified NEXMONSRC_DIR directory exists
513 513 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
514 514 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
515 515 exit 1
516 516 fi
517 517
518 518 # Check if specified CHROOT_SCRIPTS directory exists
519 519 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
520 520 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
521 521 exit 1
522 522 fi
523 523
524 524 # Check if specified device mapping already exists (will be used by cryptsetup)
525 525 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
526 526 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
527 527 exit 1
528 528 fi
529 529
530 530 # Don't clobber an old build
531 531 if [ -e "$BUILDDIR" ] ; then
532 532 echo "error: directory ${BUILDDIR} already exists, not proceeding"
533 533 exit 1
534 534 fi
535 535
536 536 # Setup chroot directory
537 537 mkdir -p "${R}"
538 538
539 539 # Check if build directory has enough of free disk space >512MB
540 540 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
541 541 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
542 542 exit 1
543 543 fi
544 544
545 545 set -x
546 546
547 547 # Call "cleanup" function on various signals and errors
548 548 trap cleanup 0 1 2 3 6
549 549
550 550 # Add required packages for the minbase installation
551 551 if [ "$ENABLE_MINBASE" = true ] ; then
552 552 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
553 553 fi
554 554
555 555 # Add parted package, required to get partprobe utility
556 556 if [ "$EXPANDROOT" = true ] ; then
557 557 APT_INCLUDES="${APT_INCLUDES},parted"
558 558 fi
559 559
560 560 # Add dphys-swapfile package, required to enable swap
561 561 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
562 562 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
563 563 fi
564 564
565 565 # Add dbus package, recommended if using systemd
566 566 if [ "$ENABLE_DBUS" = true ] ; then
567 567 APT_INCLUDES="${APT_INCLUDES},dbus"
568 568 fi
569 569
570 570 # Add iptables IPv4/IPv6 package
571 571 if [ "$ENABLE_IPTABLES" = true ] ; then
572 572 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
573 573 fi
574 574 # Add apparmor for KERNEL_SECURITY
575 575 if [ "$KERNEL_SECURITY" = true ] ; then
576 576 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
577 577 fi
578 578
579 579 # Add openssh server package
580 580 if [ "$ENABLE_SSHD" = true ] ; then
581 581 APT_INCLUDES="${APT_INCLUDES},openssh-server"
582 582 fi
583 583
584 584 # Add alsa-utils package
585 585 if [ "$ENABLE_SOUND" = true ] ; then
586 586 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
587 587 fi
588 588
589 589 # Add rng-tools package
590 590 if [ "$ENABLE_HWRANDOM" = true ] ; then
591 591 APT_INCLUDES="${APT_INCLUDES},rng-tools"
592 592 fi
593 593
594 594 # Add fbturbo video driver
595 595 if [ "$ENABLE_FBTURBO" = true ] ; then
596 596 # Enable xorg package dependencies
597 597 ENABLE_XORG=true
598 598 fi
599 599
600 600 # Add user defined window manager package
601 601 if [ -n "$ENABLE_WM" ] ; then
602 602 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
603 603
604 604 # Enable xorg package dependencies
605 605 ENABLE_XORG=true
606 606 fi
607 607
608 608 # Add xorg package
609 609 if [ "$ENABLE_XORG" = true ] ; then
610 610 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
611 611 fi
612 612
613 613 # Replace selected packages with smaller clones
614 614 if [ "$ENABLE_REDUCE" = true ] ; then
615 615 # Add levee package instead of vim-tiny
616 616 if [ "$REDUCE_VIM" = true ] ; then
617 617 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
618 618 fi
619 619
620 620 # Add dropbear package instead of openssh-server
621 621 if [ "$REDUCE_SSHD" = true ] ; then
622 622 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
623 623 fi
624 624 fi
625 625
626 626 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
627 627 if [ "$ENABLE_SYSVINIT" = false ] ; then
628 628 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
629 629 fi
630 630
631 631 # Configure kernel sources if no KERNELSRC_DIR
632 632 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
633 633 KERNELSRC_CONFIG=true
634 634 fi
635 635
636 636 # Configure reduced kernel
637 637 if [ "$KERNEL_REDUCE" = true ] ; then
638 638 KERNELSRC_CONFIG=false
639 639 fi
640 640
641 641 # Configure qemu compatible kernel
642 642 if [ "$ENABLE_QEMU" = true ] ; then
643 643 DTB_FILE=vexpress-v2p-ca15_a7.dtb
644 644 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
645 645 KERNEL_DEFCONFIG="vexpress_defconfig"
646 646 if [ "$KERNEL_MENUCONFIG" = false ] ; then
647 647 KERNEL_OLDDEFCONFIG=true
648 648 fi
649 649 fi
650 650
651 651 # Execute bootstrap scripts
652 652 for SCRIPT in bootstrap.d/*.sh; do
653 653 head -n 3 "$SCRIPT"
654 654 . "$SCRIPT"
655 655 done
656 656
657 657 ## Execute custom bootstrap scripts
658 658 if [ -d "custom.d" ] ; then
659 659 for SCRIPT in custom.d/*.sh; do
660 660 . "$SCRIPT"
661 661 done
662 662 fi
663 663
664 664 # Execute custom scripts inside the chroot
665 665 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
666 666 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
667 667 chroot_exec /bin/bash -x <<'EOF'
668 668 for SCRIPT in /chroot_scripts/* ; do
669 669 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
670 670 $SCRIPT
671 671 fi
672 672 done
673 673 EOF
674 674 rm -rf "${R}/chroot_scripts"
675 675 fi
676 676
677 677 # Remove c/c++ build environment from the chroot
678 678 chroot_remove_cc
679 679
680 680 # Generate required machine-id
681 681 MACHINE_ID=$(dbus-uuidgen)
682 682 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
683 683 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
684 684
685 685 # APT Cleanup
686 686 chroot_exec apt-get -y clean
687 687 chroot_exec apt-get -y autoclean
688 688 chroot_exec apt-get -y autoremove
689 689
690 690 # Unmount mounted filesystems
691 691 umount -l "${R}/proc"
692 692 umount -l "${R}/sys"
693 693
694 694 # Clean up directories
695 695 rm -rf "${R}/run/*"
696 696 rm -rf "${R}/tmp/*"
697 697
698 698 # Clean up APT proxy settings
699 699 if [ "$KEEP_APT_PROXY" = false ] ; then
700 700 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
701 701 fi
702 702
703 703 # Clean up files
704 704 rm -f "${ETC_DIR}/ssh/ssh_host_*"
705 705 rm -f "${ETC_DIR}/dropbear/dropbear_*"
706 706 rm -f "${ETC_DIR}/apt/sources.list.save"
707 707 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
708 708 rm -f "${ETC_DIR}/*-"
709 709 rm -f "${ETC_DIR}/resolv.conf"
710 710 rm -f "${R}/root/.bash_history"
711 711 rm -f "${R}/var/lib/urandom/random-seed"
712 712 rm -f "${R}/initrd.img"
713 713 rm -f "${R}/vmlinuz"
714 714 rm -f "${R}${QEMU_BINARY}"
715 715
716 716 if [ "$ENABLE_QEMU" = true ] ; then
717 717 # Setup QEMU directory
718 718 mkdir "${BASEDIR}/qemu"
719 719
720 720 # Copy kernel image to QEMU directory
721 721 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
722 722
723 723 # Copy kernel config to QEMU directory
724 724 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
725 725
726 726 # Copy kernel dtbs to QEMU directory
727 727 for dtb in "${BOOT_DIR}/"*.dtb ; do
728 728 if [ -f "${dtb}" ] ; then
729 729 install_readonly "${dtb}" "${BASEDIR}/qemu/"
730 730 fi
731 731 done
732 732
733 733 # Copy kernel overlays to QEMU directory
734 734 if [ -d "${BOOT_DIR}/overlays" ] ; then
735 735 # Setup overlays dtbs directory
736 736 mkdir "${BASEDIR}/qemu/overlays"
737 737
738 738 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
739 739 if [ -f "${dtb}" ] ; then
740 740 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
741 741 fi
742 742 done
743 743 fi
744 744
745 745 # Copy u-boot files to QEMU directory
746 746 if [ "$ENABLE_UBOOT" = true ] ; then
747 747 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
748 748 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
749 749 fi
750 750 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
751 751 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
752 752 fi
753 753 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
754 754 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
755 755 fi
756 756 fi
757 757
758 758 # Copy initramfs to QEMU directory
759 759 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
760 760 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
761 761 fi
762 762 fi
763 763
764 764 # Calculate size of the chroot directory in KB
765 765 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
766 766
767 767 # Calculate the amount of needed 512 Byte sectors
768 768 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
769 769 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
770 770 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
771 771
772 772 # The root partition is EXT4
773 773 # This means more space than the actual used space of the chroot is used.
774 774 # As overhead for journaling and reserved blocks 35% are added.
775 775 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
776 776
777 777 # Calculate required image size in 512 Byte sectors
778 778 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
779 779
780 780 # Prepare image file
781 781 if [ "$ENABLE_SPLITFS" = true ] ; then
782 782 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
783 783 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
784 784 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
785 785 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
786 786
787 787 # Write firmware/boot partition tables
788 788 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
789 789 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
790 790 EOM
791 791
792 792 # Write root partition table
793 793 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
794 794 ${TABLE_SECTORS},${ROOT_SECTORS},83
795 795 EOM
796 796
797 797 # Setup temporary loop devices
798 798 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
799 799 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
800 800 else # ENABLE_SPLITFS=false
801 801 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
802 802 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
803 803
804 804 # Write partition table
805 805 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
806 806 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
807 807 ${ROOT_OFFSET},${ROOT_SECTORS},83
808 808 EOM
809 809
810 810 # Setup temporary loop devices
811 811 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
812 812 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
813 813 fi
814 814
815 815 if [ "$ENABLE_CRYPTFS" = true ] ; then
816 816 # Create dummy ext4 fs
817 817 mkfs.ext4 "$ROOT_LOOP"
818 818
819 819 # Setup password keyfile
820 820 touch .password
821 821 chmod 600 .password
822 822 echo -n ${CRYPTFS_PASSWORD} > .password
823 823
824 824 # Initialize encrypted partition
825 825 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
826 826
827 827 # Open encrypted partition and setup mapping
828 828 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
829 829
830 830 # Secure delete password keyfile
831 831 shred -zu .password
832 832
833 833 # Update temporary loop device
834 834 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
835 835
836 836 # Wipe encrypted partition (encryption cipher is used for randomness)
837 837 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
838 838 fi
839 839
840 840 # Build filesystems
841 841 mkfs.vfat "$FRMW_LOOP"
842 842 mkfs.ext4 "$ROOT_LOOP"
843 843
844 844 # Mount the temporary loop devices
845 845 mkdir -p "$BUILDDIR/mount"
846 846 mount "$ROOT_LOOP" "$BUILDDIR/mount"
847 847
848 848 mkdir -p "$BUILDDIR/mount/boot/firmware"
849 849 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
850 850
851 851 # Copy all files from the chroot to the loop device mount point directory
852 852 rsync -a "${R}/" "$BUILDDIR/mount/"
853 853
854 854 # Unmount all temporary loop devices and mount points
855 855 cleanup
856 856
857 857 # Create block map file(s) of image(s)
858 858 if [ "$ENABLE_SPLITFS" = true ] ; then
859 859 # Create block map files for "bmaptool"
860 860 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
861 861 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
862 862
863 863 # Image was successfully created
864 864 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
865 865 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
866 866 else
867 867 # Create block map file for "bmaptool"
868 868 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
869 869
870 870 # Image was successfully created
871 871 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
872 872
873 873 # Create qemu qcow2 image
874 874 if [ "$ENABLE_QEMU" = true ] ; then
875 875 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
876 876 QEMU_SIZE=16G
877 877
878 878 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
879 879 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
880 880
881 881 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
882 882 fi
883 883 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant